﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using WsNetSendLib;

namespace CsDemo
{
    public partial class Form1 : Form
    {      
        CallbackNewMsg myCallBack;

        public static string GetStateName( int aState )
        {
            switch (aState)
            {
                case WsNetSend.WSNS_STATE_NONETWORK: return "Network not found";
                case WsNetSend.WSNS_STATE_INACTIVE: return "Offline";
                case WsNetSend.WSNS_STATE_ACTIVATION: return "Registering...";
                case WsNetSend.WSNS_STATE_ACTIVE: return "Online"; 
                default: return "?";
            };
        }

        public static void NewMsgCallback(string aFrom, string aTo, string aMsg)
        {
            Program.formMain.OnNewMsg(aFrom, aTo, aMsg);
        }

        public void OnNewMsg(string aFrom, string aTo, string aMsg)
        {
            if (this.textBox2.InvokeRequired)
            {
                CallbackNewMsg d = new CallbackNewMsg(OnNewMsg);
                this.Invoke(d, new object[] { aFrom, aTo, aMsg });
            }
            else
            {
                this.textBox2.AppendText("From: " + aFrom + "\r\n");
                this.textBox2.AppendText("To: " + aTo + "\r\n");
                this.textBox2.AppendText(aMsg + "\r\n");
                this.textBox2.AppendText("\r\n");
           }

        }

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            myCallBack = new CallbackNewMsg(NewMsgCallback);

            WsNetSend.NetsendBroadcastInitialize();
            WsNetSend.NetsendUnicastInitialize();

            textBox1.Text = Environment.MachineName;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            WsNetSend.NetsendBroadcastDeactivate();
            WsNetSend.NetsendUnicastDeactivate();

            WsNetSend.NetsendBroadcastFinalize();
            WsNetSend.NetsendUnicastFinalize();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            WsNetSend.NetsendBroadcastSetOnNewMsg(myCallBack);
            WsNetSend.NetsendBroadcastActivate();

            WsNetSend.NetsendUnicastAddName(textBox1.Text);
            WsNetSend.NetsendUnicastSetOnNewMsg(myCallBack);
            WsNetSend.NetsendUnicastActivate();

            textBox1.Enabled = false;
            button1.Enabled = false;
            button2.Enabled = true;
            button3.Enabled = true;
            textBox2.Enabled = true;
            textBox4.Enabled = true;
            radioButton1.Enabled = true;
            radioButton2.Enabled = true;
            textBox3.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            WsNetSend.NetsendBroadcastDeactivate();
            WsNetSend.NetsendUnicastDeactivate();

            textBox1.Enabled = true;
            button1.Enabled = true;
            button2.Enabled = false;
            button3.Enabled = false;
            textBox2.Enabled = false;
            textBox4.Enabled = false;
            radioButton1.Enabled = false;
            radioButton2.Enabled = false;
            textBox3.Enabled = false;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            int r;

            if (radioButton1.Checked)
                r = WsNetSend.NetsendUnicastSendMsgEx(textBox4.Text, textBox3.Text, textBox1.Text);
            else
                r = WsNetSend.NetsendBroadcastSendMsgEx(textBox4.Text, textBox3.Text, textBox1.Text);

            if (r != WsNetSend.WSNS_RESULT_SUCCESS)
                MessageBox.Show("Unknown error");
            else
                textBox3.Clear();
       }

        private void button4_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int stateb = 0, stateu = 0;
            string stnameu, stnameb;

            if (WsNetSend.NetsendUnicastGetState(textBox1.Text, ref stateu) == WsNetSend.WSNS_RESULT_SUCCESS)
            {
                stnameu = GetStateName(stateu);
                toolStripStatusLabel1.Text = "Personal name (" + textBox1.Text + ") - " + stnameu;
            };

            if (WsNetSend.NetsendBroadcastGetState(ref stateb) == WsNetSend.WSNS_RESULT_SUCCESS)
            {
                stnameb = GetStateName(stateb);
                toolStripStatusLabel2.Text = "Group name (*) - " +stnameb;
            };

        }



    }
}
