﻿/******************************************************
*                                                     *  
*       Winsent Net Send SDK                          *  
*                                                     *  
*       Winsent Net Send SDK Library Interface Unit   *  
*                                                     *  
*       Copyright (c) 2010-2014, Winsent Lab          *  
*       http://www.winsentlab.com                     *  
*                                                     *  
*                                                     *  
*******************************************************/
using System;
using System.Runtime.InteropServices;

namespace WsNetSendLib
{
    public delegate void CallbackNewMsg(string aFrom, string aTo, string aMsg);

    public class WsNetSend
    {
        public const int WSNS_RESULT_SUCCESS = 0;
        public const int WSNS_RESULT_NOTINITIALIZED = 1;
        public const int WSNS_RESULT_ALREADYINITIALIZED = 2;

        public const int WSNS_RESULT_SENDUNKNOWNERROR = 101;
        public const int WSNS_RESULT_SENDRECIPIENTNOTFOUND = 102;
        public const int WSNS_RESULT_SENDTRANSMISSIONERROR = 103;
        public const int WSNS_RESULT_SENDNOINTERFACEAVAIL = 104;

        public const int WSNS_STATE_UNKNOWN = 0;
        public const int WSNS_STATE_NONETWORK = 1;
        public const int WSNS_STATE_INACTIVE = 2;
        public const int WSNS_STATE_ACTIVATION = 3;
        public const int WSNS_STATE_ACTIVE = 4;

        [DllImport("wsnslib.dll", EntryPoint = "NetsendUnicastInitialize")]
        public static extern int NetsendUnicastInitialize();
        [DllImport("wsnslib.dll", EntryPoint = "NetsendUnicastFinalize")]
        public static extern int NetsendUnicastFinalize();
        [DllImport("wsnslib.dll", EntryPoint = "NetsendUnicastActivate")]
        public static extern int NetsendUnicastActivate();
        [DllImport("wsnslib.dll", EntryPoint = "NetsendUnicastDeactivate")]
        public static extern int NetsendUnicastDeactivate();
        [DllImport("wsnslib.dll", EntryPoint = "NetsendUnicastAddName")]
        public static extern int NetsendUnicastAddName(string aName);
        [DllImport("wsnslib.dll", EntryPoint = "NetsendUnicastDelName")]
        public static extern int NetsendUnicastDelName(string aName);
        [DllImport("wsnslib.dll", EntryPoint = "NetsendUnicastSetOnNewMsg")]
        public static extern int NetsendUnicastSetOnNewMsg(CallbackNewMsg aCallback);
        [DllImport("wsnslib.dll", EntryPoint = "NetsendUnicastSendMsg")]
        public static extern int NetsendUnicastSendMsg(string aAddr, string aMsg);
        [DllImport("wsnslib.dll", EntryPoint = "NetsendUnicastSendMsgEx")]
        public static extern int NetsendUnicastSendMsgEx(string aAddr, string aMsg, string aSign);
        [DllImport("wsnslib.dll", EntryPoint = "NetsendUnicastGetState")]
        public static extern int NetsendUnicastGetState(string aName, ref int aState);
        [DllImport("wsnslib.dll", EntryPoint = "NetsendUnicastSetSendTimeout")]
        public static extern int NetsendUnicastSetSendTimeout(int aTimeout);
        [DllImport("wsnslib.dll", EntryPoint = "NetsendBroadcastInitialize")]
        public static extern int NetsendBroadcastInitialize();
        [DllImport("wsnslib.dll", EntryPoint = "NetsendBroadcastFinalize")]
        public static extern int NetsendBroadcastFinalize();
        [DllImport("wsnslib.dll", EntryPoint = "NetsendBroadcastActivate")]
        public static extern int NetsendBroadcastActivate();
        [DllImport("wsnslib.dll", EntryPoint = "NetsendBroadcastDeactivate")]
        public static extern int NetsendBroadcastDeactivate();
        [DllImport("wsnslib.dll", EntryPoint = "NetsendBroadcastSetOnNewMsg")]
        public static extern int NetsendBroadcastSetOnNewMsg(CallbackNewMsg aCallback);
        [DllImport("wsnslib.dll", EntryPoint = "NetsendBroadcastSendMsg")]
        public static extern int NetsendBroadcastSendMsg(string aAddr, string aMsg);
        [DllImport("wsnslib.dll", EntryPoint = "NetsendBroadcastSendMsgEx")]
        public static extern int NetsendBroadcastSendMsgEx(string aAddr, string aMsg, string aSign);
        [DllImport("wsnslib.dll", EntryPoint = "NetsendBroadcastGetState")]
        public static extern int NetsendBroadcastGetState(ref int aState);


    }
}
